#!/bin/sh
synolxa=2.6.32
synofam=88f628x
synolva=5004
synolvb=5510
synopat=linux-${synolxa}-${synofam}-${synolva}-to-${synolvb}-v2.patch

if [ ! -e ${synopat} ]; then
  synopat=linux-${synolxa}-${synofam}-${synolva}-to-${synolvb}.patch
fi

if [ "X$1" != "X" ]; then
  synolva=$1
fi
if [ "X$2" != "X" ]; then
  synolvb=$2
fi
if [ "X$3" != "X" ]; then
  synopat=$3
fi

grep -B1 -E '^\+#ifdef.*MY_ABC_HERE' ${synopat} | grep -A1 '#ifdef.*SYNO_' | grep -B1 -E '^\+#ifdef.*MY_ABC_HERE' | grep SYNO_ | sed s/'^-#ifdef '/''/g | sed s/'^-#ifdef.SYNO_'/'SYNO_'/g | tr -d ' ' | sort | uniq > _defabc-${synolva}-on.txt
grep -B1 -E '^\+#ifndef.*MY_ABC_HERE' ${synopat} | grep -A1 '#ifndef.*SYNO_' | grep -B1 -E '^\+#ifndef.*MY_ABC_HERE' | grep SYNO_ | sed s/'^-#ifndef '/''/g | sed s/'^-#ifndef.SYNO_'/'SYNO_'/g | tr -d ' ' | sort | uniq >> _defabc-${synolva}-on.txt

mv _defabc-${synolva}-on.txt _defabc-${synolva}-on1.txt
cat _defabc-${synolva}-on1.txt | sort | uniq > _defabc-${synolva}-on.txt

grep -B1 -E '^\+#ifdef.*MY_DEF_HERE' ${synopat} | grep -A1 '#ifdef.*SYNO_' | grep -B1 -E '^\+#ifdef.*MY_DEF_HERE' | grep SYNO_ | sed s/'^-#ifdef '/''/g | sed s/'^-#ifdef.SYNO_'/'SYNO_'/g | tr -d ' ' | sort | uniq > _defabc-${synolva}-off.txt
grep -B1 -E '^\+#ifndef.*MY_DEF_HERE' ${synopat} | grep -A1 '#ifndef.*SYNO_' | grep -B1 -E '^\+#ifndef.*MY_DEF_HERE' | grep SYNO_ | sed s/'^-#ifndef '/''/g | sed s/'^-#ifndef.SYNO_'/'SYNO_'/g | tr -d ' ' | sort | uniq >> _defabc-${synolva}-off.txt

mv _defabc-${synolva}-off.txt _defabc-${synolva}-off1.txt
cat _defabc-${synolva}-off1.txt | sort | uniq > _defabc-${synolva}-off.txt
